-----------------------------------------------------------------------------------------------
-- Client Lua Script for Quickbuffidcap
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- Quickbuffidcap Module Definition
-----------------------------------------------------------------------------------------------
local Quickbuffidcap = {} 

 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
local tQuickBuffs = {} 

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function Quickbuffidcap:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function Quickbuffidcap:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
	
	
end
 

-----------------------------------------------------------------------------------------------
-- Quickbuffidcap OnLoad
-----------------------------------------------------------------------------------------------
function Quickbuffidcap:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("Quickbuffidcap.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- Quickbuffidcap OnDocLoaded
-----------------------------------------------------------------------------------------------
function Quickbuffidcap:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "Alert", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		self.wndOpts = Apollo.LoadForm(self.xmlDoc, "Options", nil, self)
		if self.wndOpts == nil then
			Apollo.AddAddonErrorText(self, "Could not load the Options window for some reason.")
			return
		end
		self.wndAdmin = Apollo.LoadForm(self.xmlDoc, "AdminForm", nil, self)
		if self.wndAdmin == nil then
			Apollo.AddAddonErrorText(self, "Could not load the Admin window for some reason.")
			return
		end
		Apollo.RegisterEventHandler("WindowManagementReady", 			"OnWindowManagementReady", self)
	    self.wndMain:Show(false, true)
		self.wndAdmin:Show(false, true)
		self.wndOpts:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("dabomb", "OnQuickbuffidcapOn", self)
		Apollo.RegisterSlashCommand("dabomboff", "onDaBombOFF", self)
		Apollo.RegisterSlashCommand("dabombopts", "OnOpts", self)
		Apollo.RegisterSlashCommand("dabombAdmin", "OnAdmin", self)
		Apollo.RegisterSlashCommand("dabombspew", "OnSpewCheck", self)
		Apollo.RegisterSlashCommand("dabombshockwave", "OnShockwaveCheck", self)
		Apollo.RegisterSlashCommand("dabombsmallbomb", "OnBombCheck", self)
		Apollo.RegisterEventHandler("CombatLogDamage", "OnDamageDealt", self)
		Apollo.RegisterEventHandler("UnitEnteredCombat", "OnUnitCombat", self)
		
		self.BuffWatchTimer   = ApolloTimer.Create(0.5, true, "onBuffId", self)
		self.SpellWatchTimer  = ApolloTimer.Create(0.5, true, "onSpellWatch", self)
		self.FirstSpewTimer   = ApolloTimer.Create(28.0, false, "onSpewTimer", self)
		self.PopupTimer       = ApolloTimer.Create(2.0, false, "onPopupTimer", self)
		self.bombTimer        = ApolloTimer.Create(10.0, false,"onBombShoutTimer",self)
		self.SpellWatchTimer:Stop()
		self.FirstSpewTimer:Stop()
		self.PopupTimer:Stop()
		self.bombTimer:Stop()
		self.BuffWatchTimer:Stop()
		-- Do additional Addon initialization here
		
	    self.tCombatInfo = {}
			self.tCombatInfo["AntiSpam"] = false
			self.tCombatInfo["abc"] = "Datascape Gridrunner" -- "Tsulong Thanksforallthefish" --Datascape Gridrunner
			self.tCombatInfo["bCombat"] = false
			self.tCombatInfo["uMyTarget"] = false
			self.tCombatInfo["strSpellCasted"] = false
			self.tCombatInfo["alertoff"] = false
			self.tCombatInfo["failoff"] = false
			self.tCombatInfo["SpewAntiSpam"] = false
			self.tCombatInfo["timers"] = {}
			self.tCombatInfo["version"] = "4.0"
				self.tCombatInfo["timers"].spew = 35.0
				self.tCombatInfo["timers"].shockwave = 15.0 
				
		self.ShockwaveTimer = ApolloTimer.Create(self.tCombatInfo["timers"].shockwave, false, "onShockwaveTimer", self)
		self.ShockwaveTimer:Stop()
		self.SpewTimer = ApolloTimer.Create(self.tCombatInfo["timers"].spew, false, "onSpewTimer", self)
		self.SpewTimer:Stop()
		self.SpewAntiSpamTimer = ApolloTimer.Create(7.0, true, "onSpewAntiSpamTimer", self)
		self.SpewAntiSpamTimer:Stop()

		
		--self.wndMain:SetAnchorPoints(self.tSettings["anchor"].1,self.tSettings["anchor"].2,self.tSettings["anchor"].3,self.tSettings["anchor"].4)
		--self.wndMain:SetAnchorOffsets(tSettings["offset"],)
	end
end

-----------------------------------------------------------------------------------------------
-- Quickbuffidcap Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/dabomb"
function Quickbuffidcap:OnQuickbuffidcapOn()
	self.wndMain:FindChild("strMessage"):SetText("Click red lock to save position!")
	self.wndMain:AddStyle("Moveable")
	self.wndMain:FindChild("lock"):Show(true,true)
	self.wndMain:Show(true,false)-- show the window
--	SendVarToRover("WOO", self.tCombatInfo)
	
end
-- Admin Form
function Quickbuffidcap:OnAdmin()
 --if GameLib.GetPlayerUnit():GetName() == self.tCombatInfo["abc"] then
	self.wndAdmin:Show(true,false)-- show the false
-- else
	Print("Insuffiecent Access")
-- end	
end
-- options /dabombopts
function Quickbuffidcap:OnOpts()
	if self.tCombatInfo["failoff"] then
	self.wndOpts:SetRadioSelButton("failwatch",self.wndOpts:FindChild("failWatchOn"))
	self.wndOpts:Show(true,false)-- show the window
	else
	self.wndOpts:SetRadioSelButton("failwatch",self.wndOpts:FindChild("failWatchOff"))
	self.wndOpts:Show(true,false)-- show the window
	end
	
end
-- turnoff timer alerts.
function Quickbuffidcap:onDaBombOFF()
	if self.tCombatInfo["alertoff"] == false then
		self.tCombatInfo["alertoff"] = true
	else
		self.tCombatInfo["alertoff"] = false
	end
end

--  /dabombspew
function Quickbuffidcap:OnSpewCheck()
	self:onSpewTimer()
end

-- when /dabombshockwave
function Quickbuffidcap:OnShockwaveCheck()
	self:onShockwaveTimer()
end
-- when /dabombsmallbomb
function Quickbuffidcap:OnBombCheck()
	self:ShoutBomb()
end

--DaBomb save / reload functionality
function Quickbuffidcap:OnSave(eType)
 if eLevel ~= GameLib.CodeEnumAddonSaveLevel.General then
         return self.tCombatInfo 
    end	
	
	return nil
	end

function Quickbuffidcap:OnRestore(eType, tSavedData)
if self.tCombatInfo then
	self.tCombatInfo = tSavedData
end
end

function Quickbuffidcap:OnWindowManagementReady()
	Event_FireGenericEvent("WindowManagementRegister", {strName = "DaBomb", nSaveVersion = knSaveVersion})
	Event_FireGenericEvent("WindowManagementAdd", {wnd = self.wndMain, strName = "DaBomb"})
	Event_FireGenericEvent("WindowManagementRegister", {strName = "DaBombOptions", nSaveVersion = knSaveVersion})
	Event_FireGenericEvent("WindowManagementAdd", {wnd = self.wndOpts, strName = "DaBombOptions"})
	
--[[	SendVarToRover("test",GuildLib.GetGuilds())
	SendVarToRover("test 2",Guild:GetChannel())

	print("DaBomb Version ".. self.tCombatInfo["version"] .. " by Tsulong(Datascape Gridrunner) <Nostalgia> on Entity-NA has been loaded.")
	self.chanDaBomb = ICCommLib.JoinChannel("chanDaBomb",ICCommLib.CodeEnumICCommChannelType.Global)
		GameLib.GetPlayerUnit():GetGuildName()
	Print(GameLib.GetPlayerUnit():GetGuildName() .. "_DaBomb")
	SendVarToRover(self.chanDaBomb)
	self.chanDaBomb:SetReceivedMessageFunction("OnDaBombMessage",self)
	self.chanDaBomb:SetThrottledFunction("OnDaBombThrottle",self) 
	--self.chanDaBomb = ICCommLib.JoinChannel( GameLib.GetPlayerUnit():GetGuildName() .. "_DaBomb", "OnDaBombMessage", self)  
	]]---

 end

-----------------------------------------------------------------------------------------------
-- QuickbuffidcapForm Functions
-----------------------------------------------------------------------------------------------
function Quickbuffidcap:onBuffId()

local tBuffs = GameLib.GetPlayerUnit():GetBuffs()
	if tBuffs["arHarmful"] then
		local tBuffsHarm = tBuffs["arHarmful"]
		local tBuffsBene = tBuffs["arBeneficial"]
		for key,value in ipairs(tBuffsHarm) do
			local strSpellID = value.idBuff
			local strSpellName = value["splEffect"]:GetName()
			if strSpellName == "Corruption Globule" then
				self:ShoutBomb(strSpellID)
			end
		end
	end
--	l
--		--Print(strSpellName)
 	--table.insert(tQuickBuffs, {key,value,strSpellName} 
--table.insert(tQuickBuffs, tBuffs)
end

function Quickbuffidcap:OnDaBombThrottle()
--fill in later.
end


function Quickbuffidcap:ShoutBomb(strSpellId)
 if self.tCombatInfo["AntiSpam"] == false then
	self.bombTimer:Start()
	self.tCombatInfo["AntiSpam"] = true
	--table.insert(tQuickBuffs, strSpellId)
	ChatSystemLib.Command('/p ' .. GameLib.GetPlayerUnit():GetName() .. " has the small bomb!")
	self:onAlert("You have the small bomb!")
	Sound.PlayFile("dabomb.wav")
 end
end

function Quickbuffidcap:OnDamageDealt(tData)
	local bFailEnabled = self.tCombatInfo["failoff"]
	local nDmgDone = tData.nDamageAmount
	local uMyself = GameLib.GetPlayerUnit()
	local strSpellNameCBL = tData["splCallingSpell"]:GetName() 
	local uTargetHit = tData.unitTarget
	if not bFailEnabled then
		if (strSpellNameCBL == "Repugnant Spew" or strSpellNameCBL == "Shattering Shockwave" ) and uTargetHit == uMyself then
			if strSpellNameCBL == "Repugnant Spew" and self.tCombatInfo["SpewAntiSpam"] == false then
				self.tCombatInfo["SpewAntiSpam"] = true
				ChatSystemLib.Command('/e ' .. uTargetHit:GetName() .. " got hit by " .. strSpellNameCBL .. ". DaBomb Failwatch.")
			elseif strSpellNameCBL == "Repugnant Spew" and self.tCombatInfo["SpewAntiSpam"] then
			else
			ChatSystemLib.Command('/e ' .. uTargetHit:GetName() .. " got hit by " .. strSpellNameCBL .. ". DaBomb Failwatch.")
			end
		end
	end
end

function Quickbuffidcap:onBombShoutTimer()
	self.bombTimer:Stop()
	self.tCombatInfo["AntiSpam"] = false
end

function Quickbuffidcap:OnUnitCombat(id, bInCombat)
	local strMyName = GameLib.GetPlayerUnit():GetName()
	local strSpew = "Repugnant Spew"
	local strShockwave = "Shattering Shockwave"
	local strBossName = "Experiment X-89"
	if id:GetName() == strBossName and bInCombat and self.tCombatInfo["alertoff"] == false then
		self.BuffWatchTimer:Start()
		self.FirstSpewTimer:Start()
		self.tCombatInfo["uMyTarget"] = id
		self.SpellWatchTimer:Start()
	elseif id:GetName() == strBossName and bInCombat == false then
		self.tCombatInfo["uMyTarget"] = ""
		self.BuffWatchTimer:Stop()
		self.SpellWatchTimer:Stop()
		self.ShockwaveTimer:Stop()
		self.SpewTimer:Stop()
	end
end


function Quickbuffidcap:onSpellWatch()
	local strMyName = GameLib.GetPlayerUnit():GetName()
	local strSpew = "Repugnant Spew"
	local strShockwave = "Shattering Shockwave"
	local strBossName = "Experiment X-89"
	local uMyBoss = self.tCombatInfo["uMyTarget"]
	if uMyBoss:IsCasting() and uMyBoss:ShouldShowCastBar() and uMyBoss:GetCastName() == (strSpew or strShockwave) then
		if uMyBoss:GetCastName() == strSpew then
			self.SpewTimer:Start()
		else
		    self.ShockwaveTimer:Start()
		end
	end
end

function Quickbuffidcap:onFirstSpewTimer()
	self:onAlert("SPEW coming soon!")
	Sound.PlayFile("danger.wav")
end

function Quickbuffidcap:onSpewTimer()
	self:onAlert("SPEW coming soon!")
	Sound.PlayFile("danger.wav")
end

function Quickbuffidcap:onShockwaveTimer()
	self:onAlert("SHOCKWAVE coming soon!")
	Sound.PlayFile("danger.wav")
end

function Quickbuffidcap:onSpewAntiSpamTimer()
	self.tCombatInfo["SpewAntiSpam"] = false
end

---------------------------------------------------------------------------------------------------
-- Alert Functions
---------------------------------------------------------------------------------------------------

function Quickbuffidcap:onLockWindow( wndHandler, wndControl, eMouseButton )
	self.wndMain:FindChild("lock"):Show(false,true)
	self.wndMain:RemoveStyle("Moveable")
	self.wndMain:Show(false,false)
	
end

function Quickbuffidcap:onAlert(strMessage)
	self.PopupTimer:Start()
	self.wndMain:FindChild("strMessage"):SetText(strMessage)
	self.wndMain:Show(true,false)
end

function Quickbuffidcap:onPopupTimer()
self.wndMain:Show(false,false)
end



---------------------------------------------------------------------------------------------------
-- Options Functions
---------------------------------------------------------------------------------------------------
function Quickbuffidcap:onTurnOnFailwatch( wndHandler, wndControl, eMouseButton )
self.tCombatInfo["failoff"] = true
self.wndOpts:Show(false,true)
end

function Quickbuffidcap:onTurnOffFailwatch( wndHandler, wndControl, eMouseButton )
self.tCombatInfo["failoff"] = false
self.wndOpts:Show(false,true)
end


-----------------------------------------------------------------------------------------------
-- DaBomb Channel Addon Communication.
-----------------------------------------------------------------------------------------------
function Quickbuffidcap:OnDaBombMessage(channel, tMsg)
	local unit = GameLib.GetPlayerUnit()
	if type(tMsg.strName) ~= "string" then
        return
    end
	
	 if tMsg.strMessage == "ChangeSpew" and tMsg.strName == ("Tsulong Thanksforallthefish") and tMsg.strGuild == unit:GetGuildName()then
		self.tCombatInfo["timers"].spew = tMsg.nSpew
		Print("Spew Timer Changed to every " .. tostring(tMsg.nSpew).. " Seconds.")
		--self.SpewTimer:Set(tMsg.nSpew, true)
	 elseif tMsg.strMessage == "ChangeShockwave" and tMsg.strName == ("Tsulong Thanksforallthefish")and tMsg.strGuild == unit:GetGuildName() then
		self.tCombatInfo["timers"].shockwave = tMsg.nShockwave
		Print("Shockwave Timer Changed to every " .. tostring(tMsg.nShockwave).. " Seconds.")
		--self.ShockwaveTimer:Set(tMsg.nShockwave, true)
	 elseif tMsg.strMessage == "turnFailOff" and tMsg.strName == ("Tsulong Thanksforallthefish") and tMsg.strGuild == unit:GetGuildName() then
		self.tCombatInfo["failoff"] = tMsg.bFailTog
	 elseif tMsg.strMessage == "turnAlertOff" and tMsg.strName == ("Tsulong Thanksforallthefish") and tMsg.strGuild == unit:GetGuildName() then
		self.tCombatInfo["alertoff"] = tMsg.bAlertTog
	 elseif tMsg.strMessage == "ggnubs" and tMsg.strName == ("Tsulong Thanksforallthefish") and tMsg.strGuild == unit:GetGuildName() then
		Sound.PlayFile("tpir.wav")
	 elseif tMsg.strMessage == "AddonCheck" and tMsg.strName == ("Tsulong Thanksforallthefish") and tMsg.strGuild == unit:GetGuildName() then
		ChatSystemLib.Command('/y '.. "DaBomb is active.")
     elseif tMsg.strMessage == "ffkami" and tMsg.strName == ("Tsulong Thanksforallthefish") and tMsg.strGuild == unit:GetGuildName() then
		Sound.PlayFile("ffkami.wav")
	 elseif tMsg.strMessage == "ReloadTimers" and tMsg.strName == ("Tsulong Thanksforallthefish")  and tMsg.strGuild == unit:GetGuildName() then
		self.SpewTimer:Set(self.tCombatInfo["timers"].spew, true)
		self.SpewTimer:Stop()
		self.ShockwaveTimer:Set(self.tCombatInfo["timers"].shockwave, true)
		self.ShockwaveTimer:Stop()
		Print("Timer's have been Reloaded!")
	 end	
	end

---------------------------------------------------------------------------------------------------
-- AdminForm Functions
---------------------------------------------------------------------------------------------------

function Quickbuffidcap:onAddonCheck( wndHandler, wndControl, eMouseButton )
local unit = GameLib.GetPlayerUnit()
local t = {}
    t.strMessage ="AddonCheck"
	t.strGuild = unit:GetGuildName()
    t.strName = unit:GetName()
	self.chanDaBomb:SendMessage(t)
	--SendVarToRover("tData", t)
    self:OnDaBombMessage(nil, t)
end

function Quickbuffidcap:onAlertToggle( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetPlayerUnit()
	local bSendAlertTog = self.tCombatInfo["alertoff"]
	local t = {}
		t.strName = unit:GetName()
		t.strMessage = "turnAlertOff"
	    t.bAlertTog = bSendAlertTog
		t.strGuild = unit:GetGuildName()	
--		Print(tostring(t.bAlertTog))
		self.chanDaBomb:SendMessage(t)
	    self:OnDaBombMessage(nil, t)
end

function Quickbuffidcap:onGG( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetPlayerUnit()
	local t = {}
	    t.strMessage = "ggnubs"
	    t.strName = unit:GetName()
		t.strGuild = unit:GetGuildName()
		self.chanDaBomb:SendMessage(t)
	    self:OnDaBombMessage(nil, t)
end

function Quickbuffidcap:onFailToggle( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetPlayerUnit()
	local bSendFailTog = self.tCombatInfo["failoff"]
	local t = {}
		t.strName = unit:GetName()
		t.strGuild = unit:GetGuildName()
		t.strMessage = "turnFailOff"
	    t.bFailTog = bSendFailTog	
	--	Print(tostring(t.bFailTog))
		self.chanDaBomb:SendMessage(t)
	    self:OnDaBombMessage(nil, t)
end

function Quickbuffidcap:onUpdateSpew( wndHandler, wndControl, eMouseButton )
local unit = GameLib.GetPlayerUnit()
	local t = {}
	    t.strMessage = "ChangeSpew"
	    t.strName = unit:GetName()
		t.strGuild = unit:GetGuildName()
		t.nSpew = self.wndAdmin:FindChild("spewTimer"):GetText()
		self.chanDaBomb:SendMessage(t)
	    self:OnDaBombMessage(nil, t)
end 

function Quickbuffidcap:onUpdateShockwave( wndHandler, wndControl, eMouseButton )
local unit = GameLib.GetPlayerUnit()
	local t = {}
	    t.strMessage = "ChangeShockwave"
	    t.strName = unit:GetName()
		t.strGuild = unit:GetGuildName()
		t.nShockwave = self.wndAdmin:FindChild("shockwaveTimer"):GetText()
		self.chanDaBomb:SendMessage(t)
	    self:OnDaBombMessage(nil, t)
end 

function Quickbuffidcap:OnReloadTimers( wndHandler, wndControl, eMouseButton )
local unit = GameLib.GetPlayerUnit()
	local t = {}
	    t.strMessage = "ReloadTimers"
	    t.strName = unit:GetName()
		t.strGuild = unit:GetGuildName()
		self.chanDaBomb:SendMessage(t)
	    self:OnDaBombMessage(nil, t)
end 

function Quickbuffidcap:onKami( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetPlayerUnit()
	local t = {}
	    t.strMessage = "ffkami"
	    t.strName = unit:GetName()
		t.strGuild = unit:GetGuildName()
		self.chanDaBomb:SendMessage(t)
	    self:OnDaBombMessage(nil, t)
end

function Quickbuffidcap:onCloseAdmin( wndHandler, wndControl, eMouseButton )
	self.wndAdmin:Show(false,false)
end



-----------------------------------------------------------------------------------------------
-- Quickbuffidcap Instance
-----------------------------------------------------------------------------------------------
local QuickbuffidcapInst = Quickbuffidcap:new()
QuickbuffidcapInst:Init()
